from typing import Dict


class Enum:
    def __init__(self, use_case: str, table: str, name: str, value: str, index: int):
        self.use_case = use_case
        self.table = table
        self.name = name
        self.value = value
        self.index = index

    def to_serializable_dict(self) -> Dict:
        return {
            "use_case": self.use_case,
            "table": self.table,
            "name": self.name,
            "value": self.value,
            "index": self.index,
        }

    @staticmethod
    def from_serializable_dict(enum_dict: Dict):
        '''
        creates a layer object from a dictionary. has to have the following keys:
            - name
            - properties
            - cluster_properties
            - use_case
        '''
        return Enum(
            enum_dict["use_case"],
            enum_dict["table"],
            enum_dict["name"],
            enum_dict["value"],
            enum_dict["index"],
        )
